/***************************************************************************
 *                                                                         *
 *    NoMoRe++                                                             *
 *                                                                         *
 *    Copyright (C) 2003-2005 NoMoRe Developing Group                      *
 *                                                                         * 
 *    For more information, see http://www.cs.uni-potsdam.de/nomore/       *
 *    or email to nomore-dg@cs.uni-potsdam.de                              *
 *                                                                         *
 *                                                                         *
 *    This program is free software; you can redistribute it and/or        *
 *    modify it under the terms of the GNU General Public License          *
 *    as published by the Free Software Foundation; either version 2       *
 *    of the License, or (at your option) any later version.               *
 *                                                                         *
 *    This program is distributed in the hope that it will be useful,      *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 *    GNU General Public License for more details.                         *
 *                                                                         *
 *    You should have received a copy of the GNU General Public License    *
 *                                                                         * 
 ***************************************************************************/

#include <printer/stdout_printer.h>
#include <graph.h>
#include <head_node.h>
#include <iostream>

namespace NS_NOMORE {

void StdoutPrinter::operator()(int nr, const Graph& grp) {
  std::cout << "Answer: " << nr << std::endl;
  for(Graph::HeadNodeIterator it = grp.headNodesBegin(); it != grp.headNodesEnd(); ++it) {
    
    if((*it)->getColor() == Color::plus)
      std::cout << (*it)->getAtom().getName() << " ";
//      std::cout << "    Atom: " << (*it)->getAtom().getName() << " Color: " << (*it)->getColor() << std::endl;
  }
  
  std::cout << std::endl;
}

}
